import { __assign } from './../external/tslib/tslib.es6.js';
import React from 'react';
import classnames from 'classnames';
import { parseMetadata, suffixMetadata } from '@highlight-ui/utils-commons';
import { Icon } from '@highlight-ui/icon';
import { Typography } from '@highlight-ui/typography';
import styles from './Tag.module.scss.js';
import { mountRGBString, getTextColorBasedOnBGColor } from './parseColor.js';

function TagWithRef(_a, ref) {
  var _b;

  var text = _a.text,
      _c = _a.backgroundColor,
      backgroundColor = _c === void 0 ? '#DBE5EC' : _c,
      className = _a.className,
      color = _a.color,
      _d = _a.maxWidth,
      maxWidth = _d === void 0 ? 200 : _d,
      _e = _a.interaction,
      interaction = _e === void 0 ? 'none' : _e,
      metadata = _a.metadata,
      onClick = _a.onClick,
      onRemove = _a.onRemove;
  var isClickable = interaction === 'click';
  var isRemovable = interaction === 'remove';
  var tag = isClickable ? 'button' : 'div';
  var htmlAttributes = isClickable ? {
    onClick: onClick,
    type: 'button'
  } : {};
  var backgroundColorRGB = "" + mountRGBString(backgroundColor, 'var(--opacity)');
  var textColor = color || getTextColorBasedOnBGColor(backgroundColor);
  var style = {
    backgroundColor: backgroundColorRGB,
    color: textColor
  };
  return /*#__PURE__*/React.createElement(tag, __assign(__assign(__assign({}, parseMetadata(metadata)), htmlAttributes), {
    className: classnames(styles.tag, (_b = {}, _b[styles.buttonTag] = isClickable, _b), className),
    ref: ref,
    style: style
  }), /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(Typography, {
    variant: "caption-1",
    component: "span",
    style: {
      maxWidth: maxWidth
    },
    className: styles.tagText
  }, text), isRemovable && /*#__PURE__*/React.createElement("button", __assign({
    style: {
      color: textColor
    },
    className: styles.iconButton,
    type: "button",
    onClick: onRemove
  }, parseMetadata(suffixMetadata(metadata, 'remove-button'))), /*#__PURE__*/React.createElement(Icon, {
    name: "times",
    size: 10
  }))));
}

TagWithRef.displayName = 'Tag';
var Tag = /*#__PURE__*/React.forwardRef(TagWithRef);
export { TagWithRef, Tag as default };
//# sourceMappingURL=Tag.js.map
