import compose from 'lodash/fp/compose';

function hexadecimalToRgb(hex) {
  var shorthandRegex = /^#?([a-f\d])([a-f\d])([a-f\d])$/i;
  var newHex = hex.replace(shorthandRegex, function (_, r, g, b) {
    return r + r + g + g + b + b;
  });
  var result = /^#?([a-f\d]{2})([a-f\d]{2})([a-f\d]{2})$/i.exec(newHex);
  return result ? {
    r: window.parseInt(result[1], 16),
    g: window.parseInt(result[2], 16),
    b: window.parseInt(result[3], 16)
  } : null;
}

function mountRGBString(hex, opacity) {
  var _a = hexadecimalToRgb(hex) || {},
      r = _a.r,
      g = _a.g,
      b = _a.b;

  return opacity ? "rgb(" + r + ", " + g + ", " + b + ", " + opacity + ")" : "rgb(" + r + ", " + g + ", " + b + ")";
}

function getAppropriateTextColorBasedOnRGB(_a) {
  var r = _a.r,
      g = _a.g,
      b = _a.b;
  var offset = Math.round((r * 299 + g * 587 + b * 114) / 1000);
  return offset > 125 ? '#000' : '#fff';
}

var getTextColorBasedOnBGColor = compose([getAppropriateTextColorBasedOnRGB, hexadecimalToRgb]);
export { getTextColorBasedOnBGColor, mountRGBString };
//# sourceMappingURL=parseColor.js.map
